<?php 

function smarty_function_head_item($params = array(), &$smarty) 
{ 
   // Sanitize check for required parameters 
   if (empty($params["type"])) 
   { 
      $smarty->trigger_error("head_item: Missing required parameter type. Available types: js, css, meta.", E_USER_ERROR); 
   } 
   if (!in_array($params["type"], array("js", "css", "meta"))) 
   { 
      $smarty->trigger_error("head_item: Invalid type specified. Valid types: js, css, meta.", E_USER_ERROR); 
   } 
   if ($params["type"] == "js") 
   { 
      if (empty($params["src"])) 
      { 
         $smarty->trigger_error("head_item: Missing required parameter src.", E_USER_ERROR); 
      } 
      if (empty($params["files"])) 
      { 
         $smarty->trigger_error("head_item: Missing required parameter files.", E_USER_ERROR); 
      } 
      if (empty($params["jsType"])) 
      { 
         $params["jsType"] = "text/javascript"; 
      } 
   } 
   if ($params["type"] == "css") 
   { 
      if (empty($params["src"])) 
      { 
         $smarty->trigger_error("head_item: Missing required parameter src.", E_USER_ERROR); 
      } 
      if (empty($params["files"])) 
      { 
         $smarty->trigger_error("head_item: Missing required parameter files.", E_USER_ERROR); 
      } 
      if (empty($params["media"])) 
      { 
         $params["media"] = "screen"; 
      } 
   } 
   if ($params["type"] == "meta") 
   { 
      if (empty($params["name"])) 
      { 
         $smarty->trigger_error("head_item: Missing required parameter name.", E_USER_ERROR); 
      } 
      if (empty($params["content"])) 
      { 
         $smarty->trigger_error("head_item: Missing required parameter content.", E_USER_ERROR); 
      } 
   } 
    
    
   // Final output 
   $output = ""; 
   if ($params["type"] != "meta") 
   { 
      $files = explode(",", $params["files"]); 
   } 
    
   // Do the correct output 
   switch ($params["type"]) 
   { 
      // javascript 
      case "js": 
         foreach ($files as $file) 
         { 
            $output .= "<script  type=\"{$params['jsType']}\" src=\"{$params['src']}{$file}\"></script>\n"; 
         } 
      break; 
      
      // CSS 
      case "css": 
         foreach ($files as $file) 
         { 
            $output .= "<link rel='stylesheet' type=\"text/css\" media=\"{$params['media']}\" href=\"{$params['src']}{$file}\" />\n"; 
         } 
      break; 
      
      // Meta 
      case "meta": 
         $output = "<meta name=\"{$params['name']}\" content=\"{$params['content']}\" />\n"; 
      break; 
   } 
   //removing extra space at the end 
   return substr($output,0,-1); 
} 
?>