<?php 
/* 
 * Smarty plugin 
 * ------------------------------------------------------------- 
 * File:     outputfilter.head_item_add.php 
 * Type:     outputfilter 
 * Name:     head_item_add 
 * Purpose:  assign items to global template <head> section 
 * ------------------------------------------------------------- 
 */ 

/** 
 * Smarty head_item function 
 * 
 * This function provides an easy way to add javascript files, css files 
 * and meta information into your templates <head> section 
 * 
 * @author Chris York (echoDreamz) <cyork@echodreamz.com> 
 * @copyright 2009 Chris York (echoDreamz) 
 * 
 * @param String $tpl_output Template output 
 * @param Smarty $smarty Smarty object reference 
 */ 
function smarty_outputfilter_head_item_add($tpl_output, &$smarty) 
{ 
   // Regex matches 
   $matches = array(); 
    
   // Find all <smarty_head_item> sections 
   preg_match_all("{<smarty_head_item>(.*?)</smarty_head_item>}", $tpl_output, $matches); 
    
   // Remove them from the tpl source 
   $tpl_output = preg_replace("{<smarty_head_item>(.*?)</smarty_head_item>\n}", "", $tpl_output); 
    
   // Create the final template output 
   return str_replace("</head>", implode("\n", array_unique($matches[1])) . "\n</head>", $tpl_output); 
} 
?> 
